import javax.swing.JPanel;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.Color;
/**
*This is a custom subclass of J-Panel.
*This was required for custom painting of it's pane.
*<br>However the handicap of having to sub-class and paint within the subclass is that I can
*no longer call the current variables from the logo.class directly.
*<br>The custom repainting function mrepaint() calls functions in this class to set local
*variables as shadows of the current variables in the logo.class, and then calls the System's repaint()
*
*/
public class DrawField extends JPanel{
	
	/**
	*Constant field which is equivalent to half the preferred width of the pane
	*@todo Synchronize this with the current width
	*/
	final int halfwidth=400;
	/**
	*Constant field which is equivalent to half the preferred height of the pane
	*@todo Synchronize this with the current height
	*/
	final int halfheight=300;
	
	
	/**
	*Local Variable which is a reference to the actual variable in the logo.class
	*Since this is a reference, this does not require updating by the mrepaint() method
	*/
	Vector vct;
	/**
	*Local variables which are 'shadows' of the current variables in logo.class
	*These are set every time a call to mrepaint is made.
	*/
	double xx,yy,angle;
	/**
	*A boolean which states whether the turtle should be shown or hidden.
	*<br>this is set directly by logo when the usre commands so
	*/
	boolean st;
	
	/**
	*The constructor which takes a reference to the vector in which the points to be drawn in the 
	*pane are stored. The points are pushed into the vector when the user calls 'fd' or 'bk'
	*.The pushing is done by the logo class.
	*@param vct The reference to the vector vct in the logo class.
	*/
	public DrawField(Vector vct){
		this.vct=vct;
		xx=0;yy=0;angle=0;
		st=true;
	}
	
	/**
	*Variables which have been made global by choice only.
	*The function  paintComponent is likely to be called a large nuumber of times, hence
	*making the variables global would remove the need of allocation and garbage collection in every
	*call.
	*/
	double d;int s,c,ss,cc;	MyLine ml=null;
	
	
	/**
	*The custom painting function, the very functionality that made this subclass necessary.
	*<br>This function first makes a call to it's superclass' painting function, thus drawing the 
	*default pane first, and then does some custom painting. It checks the value of the boolean st, 
	*if set, it paints the turtle pointing in the direction an 'fd' command would take it.
	*it uses standard Math functions like sin and cos.
	*<br>Then it draws the lines by accessing all the elements in the vector and using the 
	*co-ordinates stored in it 
	*/ 
	protected void paintComponent(Graphics g){
		super.paintComponent(g);
		
		//------------draw turtle------------
		if(st){
			//setBackground(new Color(255,255,255));
			d=(angle*3.141592654)/(double)(180);
			s=(int)(4*Math.sin(d));
			c=(int)(4*Math.cos(d));
			
			//base of turtle
			g.drawLine(halfwidth+(int)(xx-c),
							halfheight-(int)(yy+s),
							halfwidth+(int)(xx+c),
							halfheight-(int)(yy-s)
						);
			
						
			ss=(int)(10*Math.sin(d));
			cc=(int)(10*Math.cos(d));
			
			//sides of turtle
			g.drawLine(halfwidth+(int)(xx-c),
							halfheight-(int)(yy+s),
							halfwidth+(int)(xx+ss),
							halfheight-(int)(yy+cc)
						);
			g.drawLine(halfwidth+(int)(xx+c),
							halfheight-(int)(yy-s),
							halfwidth+(int)(xx+ss),
							halfheight-(int)(yy+cc)
						);
		}
		
			
		ml=null;
		
		int i=vct.size();
		for(int j=0;j<i;j++){
			
			//Try to get an element from the vector
			try{
				ml=(MyLine)vct.elementAt(j);
			}
			catch(ArrayIndexOutOfBoundsException exc){}
			
			
			if(ml!=null){
				g.drawLine((int)ml.x1,(int)ml.y1,(int)ml.x2,(int)ml.y2);
			}
		}
	}
	
	/**
	*This is a function which is called by mrepaint() before it sets out to repaint the panes.
	*It updates the local variables in this class versus the current variables in the logo class
	*If Call to this is skipped the turtle would be inappropriately shown, but the lines would 
	*still be drawn correctly.
	*/
	public void setx(double x, double y, double angl){
		xx=x;yy=y;angle=angl;
	}
	/**
	*Self-explanatory. Called directly by the parsing function when user command 'st' is interpreted.
	*/
	public void showturtle(){
		st=true;
	}
	/**
	*Self-explanatory. Called directly by the parsing function when user command 'ht' is interpreted.
	*/
	public void hideturtle(){
		st=false;
	}
	
}
	
