import java.util.Hashtable;

/*
Completed ver 0.0
April 19, 2005 10:04:35 PM 
*/
/**
@author Sushovan De
@version 0.1
@since forever
*/
/**
* A recursive Logo command parser.
* This can Handle repeat statements to any depth.
* This is case sensitive, however.
* Not particualrly efficient.
*/
public class LineParser{
	
	/**
	* A Nested Class for function return ease
	*/	
	private class command{
		public String c;
		public int type;
		public int cur_index;
		
		public static final int TYPE_COMMAND =  1;
		public static final int TYPE_NUMBER = 2;
		public static final int TYPE_EOS = 3;
	}
	
	public interface parserconsumer{
		public void forward(double d);
		public void backward(double d);
		public void turnRight(double d);
		public void turnLeft(double d);
		public void setHead(double d);
		public void home();
		public void penUp();
		public void penDown();
		public void clear();
		public void showTurtle();
		public void hideTurtle();
	}
	
	
	public LineParser(parserconsumer pcnsmr){
		this.pc = pcnsmr;
	}
	
	parserconsumer pc;
	
	/**
	* A list of characters which will be regarded as end of token denoters.
	*/
	private static final String delemiters = "\t \n;,[";
	//                                        ^ ^ ^^^
	//                                  TAB SPACE NEWLINE ; , [
	
	/**
	* A List of allowed commands.
	* The index number of this determines the command, so order is very important.
	*/
	private String[] allowedCommands = new String[] { "fd", "bk", "rt", "lt", "seth", "repeat", "home", "pu", "pd",
														"cs", "st", "ht", "for"};
	
	public static void main(String args[]){
		
// 		LineParser lp = new LineParser();
// 		String input = "fd 100 bk 78 rt 90   seth   23.08 repeat 4[fd  100 repeat    3 [rt   6]   ]";
// 		lp.execute(input);
	}
	
	
	public void execute(String s) throws NoSuchMethodException, IllegalArgumentException{
		execute(s, new Hashtable(2));
	}
	
	/**
	* The principal function of this class.
	* This function is recursive, and keeps all the required variables strictly in its scope.
	* As a result, no info of parent command line reaches the child commands.
	* public, so can be called from outside.
	*/
	public void execute(String s, Hashtable ht) throws NoSuchMethodException, IllegalArgumentException{
		//System.out.println("hash: "+ht.get("i"));
		//System.out.println("\nExec: --"+s+"--\n");
		//The var com is present only for historical reasons. Identical to the param "s".
		String com = s.trim();
		s=com;

		//The current index of the string from where the next command has to be parsed.
		int cur_index =0;
		
		//An object of type "LineParser.command" which contains the information returned by the function get_token()
		//in this case it is usually a command
		command reply = null;
		
		//Another object of type "LineParser.command" 
		//in this case, it will usually contain the numerical parameter, if any for the command contained
		//in the object in "reply"
		command temp = null;
		
		//The main token parsing loop...
		//Loop till the end of string, or end of tokens is got.
		while(cur_index<s.length()){
			
			//Fill up the object "reply" with information about the next command.
			reply = get_token(ht, com, cur_index);
			
			//Update the current index .. getting ready for the next command.
			cur_index = reply.cur_index;
			
			//If get_token() indicates end of tokens, lets return to parent.
			if(reply.type == command.TYPE_EOS)return;
			
			//As expected, if it is a command, then..
			if(reply.type == command.TYPE_COMMAND){

				//will hold the parameter to the command
				double d = 0;
				
				//Self detection of end-of-string... should never occur, but still..
				/*if(cur_index>s.length()){ //Useless... since we can never use  >= 
					System.out.println("Self Detection Occured. cur_index = "+cur_index+", s.length()= "+s.length());	
					return;
				}*/
				
				//Find out what command.
				switch(getId(reply.c)){
					
					
					
					
					
					
					//fd : Makes the turtle go forward..
					case 0:
						//Get the parameter
						temp = get_token(ht, s,cur_index);
						cur_index = temp.cur_index;
						if(temp.type!=command.TYPE_NUMBER){
							throw new IllegalArgumentException("LineParser expected a number, found \""+temp.c+"\"");
						}
						d = Double.parseDouble(temp.c);
						
						//actual function call.
						pc.forward(d);
						break;
						
						
						
						
						
						
						
					//bk: Makes the turtle go backward..
					case 1:
						temp = get_token(ht, s,cur_index);
						cur_index = temp.cur_index;
						if(temp.type!=command.TYPE_NUMBER){
							throw new IllegalArgumentException("LineParser expected a number, found \""+temp.c+"\"");
						}
						 d = Double.parseDouble(temp.c);
						pc.backward(d);
						break;
						
						
						
						
						
						
						
					//rt: Turn Right	
					case 2:
						temp = get_token(ht, s,cur_index);
						cur_index = temp.cur_index;
						if(temp.type!=command.TYPE_NUMBER){
							throw new IllegalArgumentException("LineParser expected a number, found \""+temp.c+"\"");
						}
						 d = Double.parseDouble(temp.c);
						pc.turnRight(d);
						break;
						
						
						
						
						
						
				
					//lt: Turn Left
					case 3:
						temp = get_token(ht, s,cur_index);
						cur_index = temp.cur_index;
						if(temp.type!=command.TYPE_NUMBER){
							throw new IllegalArgumentException("LineParser expected a number, found \""+temp.c+"\"");
						}
						 d = Double.parseDouble(temp.c);
						pc.turnLeft(d);
						break;
						
						
						
						
						
						
						
						
						
						
					//seth: Set Turtle Direction
					case 4:
						temp = get_token(ht, s,cur_index);
						cur_index = temp.cur_index;
						if(temp.type!=command.TYPE_NUMBER){
							throw new IllegalArgumentException("LineParser expected a number, found \""+temp.c+"\"");
						}
						 d = Double.parseDouble(temp.c);
						pc.setHead(d);
						break;
						
						
						
						
						
						
						
						
						
					//Repeat - aha - The recursive wonder
					case 5:
						temp = get_token(ht, s,cur_index);
						cur_index = temp.cur_index;
						if(temp.type!=command.TYPE_NUMBER){
							throw new IllegalArgumentException("LineParser expected a number, found \""+temp.c+"\"");
						}
						d = Double.parseDouble(temp.c);
						
						//rpt: number of times to repeat
						int rpt = (int)d;
						
						//startindex: index of command string from where the internal command string starts
						int startindex = findStart(s, cur_index);
						
						//endindex: index of command string from where the internal command string ends
						int endindex = findEnd(s, cur_index);

						for(int hh = 0; hh<rpt;hh++)
							execute(s.substring(startindex,endindex));
							
						cur_index=endindex+2;
						break;
						
						
						
					case 6:
						pc.home();
						break;
						
						
					case 7:
						pc.penUp();
						break;
						
						
					case 8:
						pc.penDown();
						break;
						
						
						
					case 9:
						pc.clear();
						break;
						
						
					case 10:
						pc.showTurtle();
						break;
						
					case 11:
						pc.hideTurtle();
						break;
						
						
					case 12: //for
						temp = get_token(ht, s,cur_index);
						if(temp.type!=command.TYPE_COMMAND)throw new IllegalArgumentException ("Expected an identifier, found \""+temp.c+"\" .");
						if(getId(temp.c)!=-1)throw new IllegalArgumentException ("Cannot use a LOGO directive as identifier: \""+temp.c+"\" ."+"Logo index: ");
						cur_index = temp.cur_index;
						String identifier = temp.c;
						//Expecting an '=' sign..
						temp = get_token(ht, s,cur_index);
						if(!temp.c.equals("="))throw new IllegalArgumentException ("Expected an '=' sign for identifier "+identifier+", got \""+temp.c+"\". ");
						cur_index = temp.cur_index;
						//Expecting a number..
						temp = get_token(ht, s, cur_index);
						if(temp.type!=command.TYPE_NUMBER)throw new IllegalArgumentException ("Expecting a starting value for "+identifier+", got: \""+temp.c+"\". ");
						int start = 0;
						try{
							start = (int)Double.parseDouble(temp.c);
						}catch(NumberFormatException e){System.out.println("never occurs");}
						cur_index=temp.cur_index;
						//Expecting a 'to'
						temp = get_token(ht, s,cur_index);
						if(!temp.c.equalsIgnoreCase("to"))throw new IllegalArgumentException ("Expected an 'to' for identifier "+identifier+", got \""+temp.c+"\". ");
						cur_index = temp.cur_index;
						//Expecting a number..
						temp = get_token(ht, s, cur_index);
						if(temp.type!=command.TYPE_NUMBER)throw new IllegalArgumentException ("Expecting a stopping value for "+identifier+", got: \""+temp.c+"\". ");
						int stop = 0;
						try{
							stop = (int)Double.parseDouble(temp.c);
						}catch(NumberFormatException e){System.out.println("never occurs");}
						cur_index=temp.cur_index;
						
						//startindex: index of command string from where the internal command string starts
						startindex = findStart(s, cur_index);
						
						//endindex: index of command string from where the internal command string ends
						endindex = findEnd(s, cur_index);
//		System.out.println(":--) "+startindex+" to "+endindex+" for "+ stop + " minus " +start+" times.");

						Hashtable htbl = new Hashtable();
						htbl.putAll(ht);
							
						for(int hh = start; hh<stop;hh++){
							htbl.put(identifier,new Integer(hh));
							execute(s.substring(startindex,endindex),htbl);
						}
							
						cur_index=endindex+2;
						break;
						
					case -1:
						//System.out.println("Unknown command");
						throw new NoSuchMethodException("Invalid Command:  \""+reply.c+"\"");
						
						
						
						
						
						
					//should never occur
					default:
						System.out.println("Something strange..");
						break;
						


				}
						

			}
			else if(reply.type == command.TYPE_NUMBER){
				System.out.println("unexpected number: "+ reply.c);
			}
		}
	}
	
	private int findStart(String s, int cur_index){
		
		//remove leading whitespace...
		if(s.charAt(cur_index-1)=='[')return cur_index;
		char t =''; // init to an invalid char : ASCII 7
		while(true){
			t = s.charAt(cur_index);
			if(t=='[')break;
			cur_index++;
		}
		return ++cur_index;
	}
		
	
	
	private int findEnd(String s, int cur_index){
		
		//Usually this function will get the cur_index at this kind of position:
		//
		//            repeat 4[fd 100 rt 90]
		//                     ^
		//
		//
		//However, this may also occur:
		//
		//            repeat 4  [fd 100 rt 90]
		//                     ^
		//
		//
		//To protect against this, we check the char just before the cur_index, if it is '[',
		//We are sure it is case 1, else it is case 2.
		//
		//
		

		char ch='';
		int level = 0;
		if(s.charAt(cur_index-1)=='['){
			level++;
		}
		for(int i=cur_index;i<s.length();i++){
			ch = s.charAt(i);
			if(ch == '[')level++;
			else if(ch == ']'){
				level--;
				if(level==0)return i;
			}
		}
		return s.length();
					
	}
	
	
	/**
	*Gets one token from the command string
	*Also returns token type, new position of carat.
	*/
	private command get_token(Hashtable ht, String s, int cur_index){
		
		char t =''; // init to an invalid char : ASCII 7
		
		//remove leading whitespace by incrementing cur_index
		while(true){
			t = s.charAt(cur_index);
			if(!Character.isWhitespace(t))break;
			cur_index++;
		}
		
		//protect against going over the edge..
		if(cur_index>=s.length()){
			command rf = new command();
			rf.type = command.TYPE_EOS;
		}
		
		//The string used to return the token.
		String d = "";
		
		while(true){
			
			//get one character
			t=s.charAt(cur_index++);
			
			//if we are over the length of the string,
			if( cur_index >= s.length()){
				//add the last char to the reply...
				d+=t;
				break;
			}
			
			//if we have found a token terminating character (a member of delemiters)...
			if( delemiters.indexOf(t)!=-1 )break;
			
			//otherwise, simply add another character to reply.
			d+=t;
		}
		
		//create the object with which to reply..
		command cmd = new command();
		//set the string..
		cmd.c = d;
		//set the return type flag to a default of numerical.
		cmd.type = command.TYPE_NUMBER;
		try{
			Double.parseDouble(d);
		}catch(NumberFormatException e){
			//if we find not numerical, set it to command type.
			cmd.type = command.TYPE_COMMAND;
		}
		//Where we end now, is where the next time we have to start...
		cmd.cur_index = cur_index;
			
		if(cmd.type == command.TYPE_COMMAND){
			if(getId(cmd.c)==-1){
				if(ht.containsKey(cmd.c)){
					Integer dob = (Integer)ht.get(cmd.c);
					int db = dob.intValue();
					cmd.c = ""+db;
					cmd.type = command.TYPE_NUMBER;
				}
			}
		}
				
		
		//Land Ahoy!!
		return cmd;
			
	}	
	/**
	* Gets an int for a particular command string representing the command.
	*/
	private int getId(String s){
		for(int i=0;i<allowedCommands.length;i++){
			if(allowedCommands[i].equals(s))return i;
		}
		return -1;
	}
	

	
}



		/* -------------------------------------------------------------------------------*
		**																				  |
		**							
		 HARD-DISK Girls: She remembers everything, FOREVER.
		 RAM Girls: She forgets about you, the moment you turn her off.
		 WINDOWS Girls: Everyone knows that she can't do a thing right, but no one can live without her.
		 SCREENSAVER Girls: She is good for nothing but at least she is fun!
		 INTERNET Girls: Difficult to access.
		 SERVER Girls: Always busy when you need her.
		 MULTIMEDIA Girls: She makes horrible things look beautiful.
		 CD-ROM Girls: She is always faster and faster.
		 E-MAIL Girls: Every ten things she says, eight are nonsense.
		 VIRUS Girls: Also known as "WIFE"; when you are not expecting her, she comes,
		 			 installs herself and uses all your resources. If you try to uninstall
		 			 her you will lose something
		**																				  |
		** -------------------------------------------------------------------------------*/