//Sushovan De
//01:33:47 PM
//June 21, 2004
//External Dependancies: MyLine.class
//External Dependancies: DrawField.class
//External Dependancies: LineParser.class
//External Dependancies: Interface LineParser.parserconsumer



import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.io.*;


/**
*The funny little 'Programming Language that we learnt when we were young has now shown up into this 
*Java class which takes user input in a JTextField, remembers commands in a dynamic vector, and 
*interpretes commands to show them on the screen.
*/
public class logo extends JPanel 
						implements KeyListener, LineParser.parserconsumer{
							
	//-------------Compulsory Globals---------------------
	/**
	*The Logo Parser.
	*This class parses the command line and calls appropriate callback functions defined in 
	*ParserConsumer 
	*/
	LineParser myparser;
	/**
	*This is the text field that recieves user input and listens for keypress events.
	*Although whatever you type shows up in the textfield, this listens for three special keypresses:
	*<br><li>Enter Key
	*<br><li>Up Key
	*<br><li>Down Key
	*/
	public JTextField tf;
	/**
	*The vectors which store the state of the application.
	*The vector vct is the vector of points. In this class only variables of type MyLine are pushed into
	*it. It holds information about all the lines to be drawn. It can be argued that it is inefficient
	*to hold all the lines that have been drawn, but I deel that it is better than to store an array
	* of points. In any case, no speed problems were noticed. Also, as soon as the user presses 'cl'
	*this vector is cleared.
	*<br>The vector txt is the vector that stores commands.All the commands typed by the user are pushed into
	*the vector. The items in this vector are accessed by pressing the 'UP' and the 'DOWN' keys.
	*/	
	public Vector vct,txt;
	
	
	
	//Globals for good functioning
	/**
	*The current command.
	*Only for historical reasons, this is made public, although now, it can be made local in the keyReleased
	*method very safely.
	*/
	public String curr;
	/**
	*The index of the command now being displayed in the Vector txt.
	*A keyPress of 'UP' will decrease this by 1 and show the previous command. 
	*A keyPress of 'DOWN' will increase this by 1 and show the next command.
	*/
	public int currCommand;
	/**
	*The current turtle location's x co-ordinate.
	*<br>This is updated every time the turtle translates in the plane.
	*<br>This is kept in sync with the variable xx in the DrawField class
	*/
	public double xx;
	/**
	*The current turtle location's y co-ordinate.
	*<br>This is updated every time the turtle translates in the plane.
	*<br>This is kept in sync with the variable yy in the DrawField class
	*/
	public double yy;
	/**
	*The direction in which the turtle is currently pointing. 
	*<br>This is kept in sync with the variable angle in the DrawField class
	*/	
	public double angle;
	/**
	*Tells whether to paint or not.
	*This field, if false, will cause the turtle to lift it's pen off the paper and move about without
	*drawing on the pane. This is set by issuing the command 'pd' and set to false by 'pu'
	*/
	public boolean pt;
	/**
	*The pane on which drawing will take place
	*This is a custom sub-class of JPanel and has it's own painting method
	*/
	public DrawField drawfield;
	/**
	*The integer which stores half the width of the preferred width of the pane.
	*/
	public final int halfwidth=400;
	/**
	*The integer which stores half the height of the preferred height of the pane.
	*/
	public final int halfheight=300;

	/**
	* Open and Save File Dialog Boxes.
	*/
	final JFileChooser fc = new JFileChooser();
	
	/**
	* Whether a file is to be loaded
	*/
	static boolean loadFile = false;
	
	/**
	* The name of the file to be loaded
	*/
	static String filename;
	
	/**The constructor of this class.
	*This calls it's superclass' constructor, notifying that it wants a Border Layout type of Window
	*It initialises variables to convinient values.It also creates and adds the DrawField andattaches
	*a KeyListener to It. It passes a reference to the vector vct to drawfield for painting.
	*/	
	public logo(){
        super(new BorderLayout());
        
        //---------------------------CUSTOM INITS--------------------------
		vct=new Vector(10,50);
		txt=new Vector();
		currCommand=0;
		xx=0;
		yy=0;
		angle=0;
		pt=true;
		//-----------------------------------------------------------------
		
		myparser = new LineParser(this);
		
		tf=new JTextField(56);
		add(tf,BorderLayout.PAGE_START);
		drawfield=new DrawField(vct);
		drawfield.setBorder(BorderFactory.createTitledBorder("Draw Here"));
		add(drawfield,BorderLayout.CENTER);		
        tf.addKeyListener(this);
        
        if(loadFile){
	        File fl = new File(filename);
	        executeFromFile(fl);
        }
	        

        //fc.setCurrentDirectory()
		
	}
	/**
	*Does not do anything.
	*These methods, though required to be implemented by the interface KeyListener are not required.
	*/
	public void keyTyped(KeyEvent e) {}
	/**
	*Does not do anything.
	*These methods, though required to be implemented by the interface KeyListener are not required.
	*/
	public void keyPressed(KeyEvent e){}
	/**
	*This is where the keypress events are handled.
	*/
	public void keyReleased(KeyEvent e){  
		
		
    	if(e.getKeyCode()==10){//Enter
        	curr=tf.getText();
        	if(curr.equals("d"))dump();
        	txt.add(curr);
        	currCommand=txt.size();
        	tf.setText("");
        	
        	try{
        		myparser.execute(curr);
    		}
    		catch(NoSuchMethodException nmse){
	    		JOptionPane.showMessageDialog(this,
							    				nmse.getMessage(),
    											"Syntax Error",
										   		JOptionPane.ERROR_MESSAGE);
    		}
    		catch(IllegalArgumentException il){
	    		JOptionPane.showMessageDialog(this,
							    				il.getMessage(),
    											"Syntax Error",
										   		JOptionPane.ERROR_MESSAGE);
    		}
	    }
	    
		if(e.getKeyCode()==38){//Up
	    
	    	if(txt.size()==0){
		    	currCommand=0;//set the current index of command in the command vector 'txt' to 0
		    	tf.setText("");
	    	}
	    	else if(currCommand==-1){
		    	tf.setText("");
	    	}
	    	else{
		    	try{
			    	currCommand--;
			    	String g=(String)txt.elementAt(currCommand);
			    	tf.setText(g);
		    	}
		    	catch(ArrayIndexOutOfBoundsException eghg){
			    	tf.setText("");
		    	}
	    	}
		    	
    	}
    	
    	if(e.getKeyCode()==40){//Down
    	
    		if(txt.size()==0)tf.setText("");
    		else{
	    		try{    		
			    	currCommand++;
			    	String g=(String)txt.elementAt(currCommand);
			    	tf.setText(g);
			    }
		    	catch(ArrayIndexOutOfBoundsException eghg){
			    	tf.setText("");
		    	}
	    	}
    	}
	}
	
	
	
	/**
	*Creates the frame, decorates it, and shows it.
	*This is a method which is pure convention. There is nothing original, nor does anybody need to
	*improvise here. (Just like void main())
	*/
	public static void createAndShowGUI(){
		JFrame.setDefaultLookAndFeelDecorated(true);
		JFrame wow=new JFrame("Logo");
		wow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		logo newContentPane = new logo();
        newContentPane.setOpaque(true); //content panes must be opaque
        wow.setContentPane(newContentPane);
        wow.setJMenuBar(new myMenu(newContentPane));
		newContentPane.setPreferredSize(new Dimension(800,600));
		wow.pack();
		wow.setVisible(true);
		
	}


	/**
	*Sets look and feel, calls to show the frame on the Event Dispatching Thread, and returns
	*Pure Convention again.
	*/
    public static void main(String[] args) {
	    
	    if(args.length>0){
	    	logo.loadFile = true;
	    	logo.filename = args[0];
    	}
	    logo l = new logo();
	    
		try {
        //UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
        //UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel" );
        //UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel" );
        
    } catch (Exception e) { System.out.println("not found");}

        javax.swing.SwingUtilities.invokeLater(new Runnable() {
	        
            public void run() {
                createAndShowGUI();
            }
        });
    }
    
    
 
	
	/**
	*Necessary method for cutom painting.
	*No custom painting done here. When a call to repaint is made, the heirarchy of calls ensures that 
	*all components' paint method is called, thus don't worry about the method in DrawField.
	*/
	protected void paintComponent(Graphics g){
		super.paintComponent(g);
	}
	/**
	*Shows the current stack of vertices on stderr.
	*This method can be called by typing d on the textfield.
	*/	
	public void dump(){
		
		MyLine ml=null;
		int n=vct.size();
		System.out.println("The Vector is "+n+"units big.");
		for(int i=0;i<n;i++){
			try{ml=(MyLine)vct.elementAt(i);}catch(ArrayIndexOutOfBoundsException exc){System.out.println("exc!");}
			if(ml!=null){
				System.err.print("Line: ");
				System.err.print(ml.x1+",  ");
				System.err.print(ml.y1+", ");
				System.err.print(ml.x2+", ");
				System.err.print(ml.y2+".\n");
			}

		}
					System.err.println("done--------------------------");
		mrepaint();
	}
	/**
	*A custom repaint.
	*This is not a system function. I simply update the local variables in the DrawLine class
	*and then call the System's repaint()
	*/
	public void mrepaint(){
		drawfield.setx(xx,yy,angle);
		repaint();
	}

	
	
	
	
		/* -------------------------------------------------------------------------------*
		**																				  |
		**						xx and yy are the current turtle locations
		**																				  |
		** -------------------------------------------------------------------------------*/
	
	
	
	public void forward(double d){
		double direction = (angle*3.141592654)/(double)(180);
		double x = d*Math.sin(direction);
		double y = d*Math.cos(direction);
		if(pt) vct.add(new MyLine(xx+halfwidth,halfheight-yy,xx+x+halfwidth,halfheight-yy-y));
		xx+=x;yy+=y;//relocate the cursor.
		mrepaint();
	}
	public void backward(double d){
		double direction = (angle*3.141592654)/(double)(180);
		double x = - d*Math.sin(direction);
		double y = - d*Math.cos(direction);
		if(pt) vct.add(new MyLine(xx+halfwidth,halfheight-yy,xx+x+halfwidth,halfheight-yy-y));
		xx+=x;yy+=y;//relocate the cursor.
		mrepaint();
	}
	public void turnRight(double d){
		angle +=d;
		angle%=360;
		mrepaint();
	}
	public void turnLeft(double d){
		angle -=d;
		angle%=360;
		mrepaint();
	}
	public void setHead(double d){
		angle = d;
		angle%=360;
		mrepaint();
	}
	public void home(){
		if(pt)vct.add(new MyLine(xx+halfwidth,halfheight-yy,halfwidth,halfheight));
		xx=0;
		yy=0;
		mrepaint();
	}
	public void penUp(){
		pt = false;
	}
	public void penDown(){
		pt = true;
	}
	public void clear(){
		vct.clear();
		xx=0;
		yy=0;
		angle=0;
		mrepaint();
	}
	public void showTurtle(){
		drawfield.showturtle();//ST
		mrepaint();
	}
	public void hideTurtle(){
		drawfield.hideturtle();
		mrepaint();
	}
	
	
	
		/* -------------------------------------------------------------------------------*
		**																				  |
		**							End of interface functions
		**																				  |
		** -------------------------------------------------------------------------------*/
	
		
		
	public void load(){
		
		int ret = fc.showOpenDialog(this);
		if(ret != JFileChooser.APPROVE_OPTION) return;
		executeFromFile(fc.getSelectedFile());
	}
	
	public void executeFromFile(File filename){
		String s = "";
		int i=0;

		try{
			BufferedReader bf = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
			while(s!=null){
				i++;
				s=bf.readLine();
				if(s==null)break;
				s.trim();
				if(s.length()<=0)continue;
				myparser.execute(s);
			}
		}catch(NoSuchMethodException nmse){
    		JOptionPane.showMessageDialog(this,
						    				"Line "+i+": "+nmse.getMessage(),
											"Syntax Error",
									   		JOptionPane.ERROR_MESSAGE);
		}
		catch(IllegalArgumentException il){
    		JOptionPane.showMessageDialog(this,
						    				"Line "+i+": "+il.getMessage(),
											"Syntax Error",
									   		JOptionPane.ERROR_MESSAGE);
		}
		catch(IOException ioe){
    		JOptionPane.showMessageDialog(this,
						    				ioe.getMessage(),
											"File Reading Error",
									   		JOptionPane.ERROR_MESSAGE);
		}

	}
		
				
}