import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

/*
* myMenu.java
* Started April 22, 2005 09:47:13 PM 
* Sushovan De
*/

/**
* Class for the menubar in the Logo Main Window
*/
public class myMenu extends JMenuBar implements ActionListener{
	
	JMenu fileMenu;
	JMenuItem loadItem, saveItem, exitItem;
	
	logo parent;
	
	
	public myMenu(logo l){
		
		parent = l;
		
		fileMenu = new JMenu("File");
		fileMenu.setMnemonic(KeyEvent.VK_F);
		fileMenu.getAccessibleContext().setAccessibleDescription(
			"File Menu: Allows access to common file related operations");
		this.add(fileMenu);
		
		loadItem = new JMenuItem("Load script", KeyEvent.VK_L);
		loadItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, ActionEvent.CTRL_MASK));
		loadItem.getAccessibleContext().setAccessibleDescription(
			"Load: Load a file and execute the script commands in the file");
		fileMenu.add(loadItem);
		
		saveItem = new JMenuItem("Save script", KeyEvent.VK_S);
		saveItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
		saveItem.getAccessibleContext().setAccessibleDescription(
			"Save: Save the scripts to draw the current picture into a script file");
		fileMenu.add(saveItem);
		
		fileMenu.addSeparator();
		
		exitItem = new JMenuItem("Exit", KeyEvent.VK_X);
		exitItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, ActionEvent.CTRL_MASK));
		exitItem.getAccessibleContext().setAccessibleDescription(
			"Exit: Ends the current logo session");
		fileMenu.add(exitItem);
		
		loadItem.addActionListener(this);
		saveItem.addActionListener(this);
		exitItem.addActionListener(this);
		
	}
	
	public void actionPerformed(ActionEvent e){
		
		Object obj = e.getSource();
		if(obj instanceof JMenuItem){
			
			if(obj == exitItem){
				System.exit(0);
			}
			
			if(obj == saveItem){
				JFileChooser jf = new JFileChooser();
				int ret = jf.showOpenDialog(this);
				if(ret != JFileChooser.APPROVE_OPTION) return;
				
				int last = parent.txt.lastIndexOf("cs");
				last++;
				try{
					BufferedWriter bw = new BufferedWriter(
						new OutputStreamWriter(
						new FileOutputStream(jf.getSelectedFile())));
						
					for(int i=last;i<parent.txt.size();i++)
						bw.write((String)parent.txt.elementAt(i)+"\r\n");
						
					bw.flush();
					bw.close();
				}catch(FileNotFoundException fnfe){}
				catch(IOException eaa){}
				
			}
			
			if(obj == loadItem){
				parent.load();
			}
			
		}
	}
	
}
		
		
		
